/*!\file:  ElementResult.h
 * \brief abstract class for ElementResult object
 */ 


#ifndef _ELEMENTRESULT_H_
#define _ELEMENTRESULT_H_

/*Headers:*/
/*{{{1*/
#include "../Object.h"
/*}}}*/

class ElementResult:public Object{

	public: 
		
		virtual        ~ElementResult(){};
		
		virtual         ElementResult* SpawnSingElementResult(int  index)=0;
		virtual         ElementResult* SpawnBeamElementResult(int* indices)=0;
		virtual         ElementResult* SpawnTriaElementResult(int* indices)=0;
		virtual void    ProcessUnits(Parameters* parameters)=0;
		virtual int     NumberOfNodalValues(void)=0;
		virtual void    PatchFill(int row, Patch* patch)=0;

};

void NodalValuesUnitConversion(double* nodal_values, int num_nodal_values,int enum_type,Parameters* parameters);
#endif
